/*
    Nast

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

/*Sia il port scanner sigolo che multiplo soffrono di qualche problemino...
sono troppo veloci:) cio intasano il buffer...es: sul portatile con scheda
PCMCIA manda i pacchetti troppo velocemente rilevando aperte porte che non lo
sono o saltando proprio porte! Questo non capita con una normale scheda di rete
integrata in un pc "normale" (non portatile insomma).Problema del prog o hardware?
Aggiungendo un usleep(100-10) la cosa non cambia...diventa solo pi lento:(
*/

#include "include/nast.h"

/* single host syn port scanner*/
int port(u_char *dev,u_long dst_ip,libnet_plist_t *plist_p,int lg)
{
   int c, build_ip, fr=0, fd=0 ;
   libnet_t *l;
   libnet_ptag_t tcp;
   libnet_ptag_t t=0;
   struct timeval tv;
   struct servent *service;
   fd_set rfsd;
   int sd,close = 0;
   struct pcap_pkthdr pcap_h;
   struct libnet_tcp_hdr *Tcp;
   struct libnet_ipv4_hdr *ip;
   struct libnet_icmpv4_hdr *icmp;
   u_long src_ip;
   u_char *pkt;
   u_short bport = 0, eport = 0, cport = 0;
   char errbuf[LIBNET_ERRBUF_SIZE];

   tm = time(NULL);
   /* per avere sia ora che data si pu usare %c, ma il compilatore tira fuori dei warning decisamente noiosi:)*/
   strftime(timed,60,"%b %d %T",localtime(&tm));

   if(lg)
     {
	openfile();
	printf ("Waiting please... \n");
	fprintf(log, "NAST SYN PORT SCANNER REPORT\n");
	fprintf(log, "Made on %s\n\n", timed);
     }

   fprintf(log,"Wait for scanning...\n\n");
   fprintf(log,"State	       	Port		Services		Notes\n\n");

   l = libnet_init(
		   LIBNET_RAW4,                            /* injection type */
		   NULL,                                   /* network interface */
		   errbuf);                                /* errbuf */

   if (l == NULL)
     {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        return(EXIT_FAILURE);
     }
   if ((src_ip = libnet_get_ipaddr4(l))==-1)
     {
	fprintf (stderr, "Can't get local ip address : %s\n", libnet_geterror(l));
	return (-1);
     }

   tcp = 0;

   pcap_lookupnet(dev,&netp,&maskp,errbuf);

   if ((descr = pcap_open_live (dev, BUFSIZ, NOT_PROMISC, 10, errbuf))==NULL)
     {
	fprintf(stderr, "pcap_open_live() error: %s\n",errbuf);
	return -1;
     }

   sd = pcap_fileno(descr);

   if ((offset=(device(dev,descr)))==-1) return -1;

   build_ip = 1;
   while (libnet_plist_chain_next_pair(plist_p, &bport, &eport))
     {
        while (!(bport > eport) && bport != 0)
	  {
	     cport = bport++;
	     tcp = libnet_build_tcp(
				    1050,                                    /* source port */
				    cport,                                    /* destination port */
				    0x01010101,                                 /* sequence number */
				    0,                                          /* acknowledgement num */
				    TH_SYN,                                     /* control flags */
				    32767,                                      /* window size */
				    0,                                          /* checksum */
				    0,                                          /* urgent pointer */
				    LIBNET_TCP_H,                               /* TCP packet size */
				    NULL,                                       /* payload */
				    0,                                          /* payload size */
				    l,                                          /* libnet handle */
				    tcp);                                         /* libnet id */
	     if (t == -1)
	       {
		  fprintf(stderr, "Can't build TCP header: %s\n", libnet_geterror(l));
		  goto bad;
	       }

	     if (build_ip)
	       {
		  build_ip = 0;
		  t = libnet_build_ipv4(
					LIBNET_IPV4_H + LIBNET_TCP_H,               /* length */
					0,                                          /* TOS */
					242,                                        /* IP ID */
					0,                                          /* IP Frag */
					64,                                         /* TTL */
					IPPROTO_TCP,                                /* protocol */
					0,                                          /* checksum */
					src_ip,                                     /* source IP */
					dst_ip,                                     /* destination IP */
					NULL,                                       /* payload */
					0,                                          /* payload size */
					l,                                          /* libnet handle */
					0);
		  if (t == -1)
		    {
		       fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
		       goto bad;
		    }

	       }
	       /* usleep con be omissed when scanned another linux box,but if u scan a openBSD
	       it must be uesed! otherwise it find drop rule that doesn't exist!*/
	     usleep(5);
	     c = libnet_write(l);
	     if (c == -1)
	       {
		  fprintf(stderr, "Error: %s\n", libnet_geterror(l));
	       }

	     for(;;)
	       {
		  fflush (log);

	          tv.tv_sec = 2;
		  tv.tv_usec = 0;
		  FD_ZERO (&rfsd);
	          FD_SET (sd ,&rfsd);

		  pkt = (u_char *) pcap_next(descr,&pcap_h);
		  ip = (struct libnet_ipv4_hdr *) (pkt + offset);
		  icmp = (struct libnet_icmpv4_hdr *) (pkt + offset + LIBNET_IPV4_H);
		  Tcp = (struct libnet_tcp_hdr *) (pkt + offset + sizeof(struct libnet_ipv4_hdr));

		  if (Tcp->th_flags == (TH_RST|TH_ACK))
		    {
		       close++;
		       break;
		    }

		  service = getservbyport(htons(cport), "tcp");

     		/*ho lasciato gli icmp pi logici x un filtraggio...dubito che vada bene un echo_request:)*/
		  if(ip->ip_p == IPPROTO_ICMP)
		    {
		       fprintf(log,"Filtered		%d		%s", cport, (service) ? service->s_name : "unknown");
		       fprintf(log,"					");
		       switch((icmp->icmp_type))
			 {

			  case 3:
			    switch (icmp->icmp_code)
			      {
			       case 0:
				 fprintf(log,"Network Unreachable");
				 break;
			       case 1:
				 fprintf(log,"Host Unreachable");
				 break;
			       case 3:
				 fprintf(log,"Port Unreachable");
				 break;
			       case 6:
				 fprintf(log,"Destination network unknown");
				 break;
			       case 7:
				 fprintf(log,"Destination host unknown");
				 break;
			       case 8:
				 fprintf(log,"Source host isolated");
				 break;
			       case 9:
				 fprintf(log,"Destination network administratively prohibited");
				 break;
			       case 10:
				 fprintf(log,"Destination host administratively prohibited");
				 break;
			       case 11:
				 fprintf(log,"Network unreachable(tos)");
				 break;
			       case 12:
				 fprintf(log,"Host Unreachable (tos)");
				 break;
			       case 13:
				 fprintf(log,"Communication administratively prohibited");
				 break;
			      }

			    break;
			  default:
			    fprintf(log,"%i", icmp->icmp_type);
			    break;
			 }
		       fprintf(log,"(*)\n");
		       fr++;
		       break;
		    }

		  if (!select(sd+1, &rfsd, NULL, NULL, &tv))
		    {
		       //service = getservbyport(htons(cport), "tcp");
		       fprintf(log,"Filtered	%d		%s", cport,(service) ? service->s_name : "unknown");
		       fprintf(log, " 		SYN packet timeout(**)\n");
		       fd++;
		       break;
		    }
		  if (Tcp->th_seq != 0 && (Tcp->th_flags == (TH_SYN|TH_ACK)))
		    {
		       //service = getservbyport(htons(cport), "tcp");
		       fprintf(log,"Open		%d		%s", cport,(service) ? service->s_name : "unknown");
		       fprintf(log,"			None\n");
		       break;
		    }

	       }

	  }
     }
   fprintf(log,"\nAll the other %d ports are in state closed\n",close);
   if (fr!=0) fprintf(log,"(*)Possible REJECT rule in the firewall\n");
   if (fd!=0) fprintf(log,"(**)Possible DROP rule in the firewall\n");

   libnet_destroy(l);
   pcap_close(descr);
   fprintf(log,"Scanning terminated on %s\n",timed);

   if (lg)
     {
	printf ("Done! Results has been writed to '%s'\n", logname);
	fclose (log);
     }
   printf ("\n");
   getchar();
   return 0;

   bad:
   libnet_destroy(l);
   pcap_close(descr);
   fprintf (log, "Error!\n\n");

   if (lg)
     {
	printf ("Error! Results has been writed to '%s'\n", logname);
	fclose (log);
     }
   printf ("\n");
   getchar();
   return 1;

}

/* multy hosts - catch banner*/
int mport (u_char *dev, u_short ports[],int lg)
{
   struct host *uphost;
   struct servent *service;
   struct in_addr daddr;
   u_short i, j, n;
   char banner[512];
   struct sockaddr_in sin;
   char ip[20];
   int sd, r;
   struct timeval tv;
   fd_set rfds;

   /* demonize */
   if (demonize)
     bkg();

   tm = time(NULL);
   strftime(timed,60,"%b %d %T",localtime(&tm));

   if(lg)
     {
	openfile();
	printf ("Waiting please...\n");
	fprintf(log, "NAST BANNER REPORT\n");
	fprintf(log, "Made on %s\n\n", timed);
     }

   fprintf(log, "Builing hosts list... ");
   fflush (log);

   if ((uphost = map_lan(dev, 0, &n))==NULL)
     {
	fprintf (stderr, "\nCan't build truly host list! mmhhh!\nReport bug to author please\n\n");
	return -1;
     }
   if (n==0)
     {
	fprintf (stderr, "\nWhat are you doing? You are alone in this network!\n\n");
	return -1;
     }

   fprintf (log,"done");

   memset (&sin, 0, sizeof (struct sockaddr_in));
   sin.sin_family = AF_INET;

   for (i=0; i<n; i++)
     {
	sprintf(ip, "%d.%d.%d.%d", uphost[i].ip[0], uphost[i].ip[1], uphost[i].ip[2], uphost[i].ip[3]);
	daddr.s_addr = inet_addr (ip);
	sin.sin_addr = daddr;
	j = 0;
	fprintf (log,"\n\n%sIP : %s (%s) %s\n", BOLD, ip, libnet_addr2name4(inet_addr(ip), LIBNET_RESOLVE), NORMAL);
	fprintf (log,"\nOPEN PORTS\t\tBANNER\n");

	for (;;)
	  {
	     sd = socket(AF_INET, SOCK_STREAM, 0);
	     sin.sin_port = htons(ports[j]);

	     if ((connect(sd, (struct sockaddr *)&sin, sizeof(sin))) != EOF)
	       {
		  service = getservbyport(htons(ports[j]), "tcp");
		  fprintf (log,"%d (%s)", ports[j], service->s_name);

		  FD_ZERO (&rfds);
		  FD_SET (sd, &rfds);
		  tv.tv_sec=2;
		  tv.tv_usec=0;

		  /* for telnet, read two times */
		  if (ports[j]==23) 
		    recv (sd, banner, 512, 0);
		  
		  /* read the banner */
		  if (select (sd+1, &rfds, NULL, NULL, &tv))
		    {
		       memset (&banner, 0, 512);
		       r = recv (sd, banner, 512, 0);
		       if (banner[r-1]=='\n') banner[r-1]='\0';
		       fprintf (log,"\t\t%s\n", banner);
		    }

		  /* 1st time out expired */
		  else
		    {
		       /* send to /n to socket */
		       write (sd, "\n\n", 2);
		       /* reset timer */
		       FD_ZERO (&rfds);
		       FD_SET (sd, &rfds);
		       tv.tv_sec=2;
		       tv.tv_usec=0;

		       /* try a 2nd time */
		       if (select (sd+1, &rfds, NULL, NULL, &tv))
			 {
			    memset (&banner, 0, 512);
			    r = recv (sd, banner, 512, 0);
			    if (banner[r-1]=='\n') banner[r-1]='\0';
			    fprintf (log,"\t\t%s\n", banner);
			 }
		    }
	       }

	     fflush (log);
	     close (sd);
	     j++;

	     if (ports[j] == '\0') break;
	  }

     }

   free (uphost);
   fprintf(log, "\nScanning terminated on %s\n",timed);
   if (lg)
     {
	printf ("Done! Results has been writed to '%s'\n", logname);
	fclose (log);
     }

   printf ("\n");
   getchar();
   return 0;

}

int mhport(u_char *dev,libnet_plist_t *plist_p,int lg)
{
   int c, build_ip, fr=0, fd=0 ;
   libnet_t *l;
   libnet_ptag_t tcp=0;
   libnet_ptag_t t=0;
   struct timeval tv;
   struct servent *service;
   fd_set rfsd;
   int sd,close = 0;
   struct pcap_pkthdr pcap_h;
   struct libnet_tcp_hdr *Tcp;
   struct libnet_ipv4_hdr *ip;
   struct libnet_icmpv4_hdr *icmp;
   u_long src_ip = 0;
   u_char *pkt;
   u_short bport = 0, eport = 0, cport = 0, i = 0 ,n = 0;
   char errbuf[LIBNET_ERRBUF_SIZE];
   struct host * uphost;
   u_char testip[20];

   tm = time(NULL);
   strftime(timed,60,"%b %d %T",localtime(&tm));

   if(lg)
     {
	openfile();
	printf ("Waiting please...\n");
        fprintf(log, "NAST MULTI HOST PORT-SCANNER REPORT\n");
        fprintf(log, "Made on %s\n\n", timed);
     }

   fprintf(log, "Builing hosts list... ");
   fflush (log);

   if ((uphost = map_lan(dev, 0, &n))==NULL)
     {
	fprintf (stderr, "\nCan't build truly host list! mmhhh!\nReport bug to author please\n\n");
	return -1;
     }
   if (n==0)
     {
	fprintf (stderr, "\nWhat are you doing? You are alone in this network!\n\n");
	return -1;
     }

   fprintf (log,"done\n");
   sleep(1);

   for(i=0;i<n;i++)
     {

	l = libnet_init(
			LIBNET_RAW4,                            /* injection type */
			NULL,                                   /* network interface */
			errbuf);                                /* errbuf */

	if (l == NULL)
	  {
	     fprintf(stderr, "libnet_init() failed: %s", errbuf);
	     return(EXIT_FAILURE);
	  }
	if ((src_ip = libnet_get_ipaddr4(l))==-1)
	  {
	     fprintf (stderr, "Can't get local ip address : %s\n", libnet_geterror(l));
	     return (-1);
	  }

	sprintf(testip, "%d.%d.%d.%d", uphost[i].ip[0], uphost[i].ip[1], uphost[i].ip[2], uphost[i].ip[3]);
	tcp = 0; c = 0;
	fprintf(log,"\nWait for scanning...");
	fprintf(log,"%s%d.%d.%d.%d%s\n\n",BOLD, uphost[i].ip[0], uphost[i].ip[1], uphost[i].ip[2], uphost[i].ip[3],NORMAL);
	fprintf(log,"State		Port		Services		Notes\n\n");
	pcap_lookupnet(dev,&netp,&maskp,errbuf);

	if ((descr = pcap_open_live (dev, BUFSIZ, NOT_PROMISC, 10,errbuf)) == NULL)
	  {
	     fprintf(stderr, "pcap_open_live() error: %s\n",errbuf);
	     return -1;
	  }

	sd = pcap_fileno(descr);

	if ((offset=(device(dev,descr)))==-1) return -1;

	build_ip = 1;
	while (libnet_plist_chain_next_pair(plist_p, &bport, &eport))
	  {
	     while (!(bport > eport) && bport != 0)
	       {
		  cport = bport++;
		  tcp = libnet_build_tcp(
					 1050,                                    /* source port */
					 cport,                                    /* destination port */
					 1234567,                                 /* sequence number */
					 0,                                          /* acknowledgement num */
					 TH_SYN,                                     /* control flags */
					 32767,                                      /* window size */
					 0,                                          /* checksum */
					 0,                                          /* urgent pointer */
					 LIBNET_TCP_H,                               /* TCP packet size */
					 NULL,                                       /* payload */
					 0,                                          /* payload size */
					 l,                                          /* libnet handle */
					 tcp);                                         /* libnet id */
		  if (t == -1)
		    {
		       fprintf(stderr, "Can't build TCP header: %s\n", libnet_geterror(l));
		       libnet_destroy(l);
		       pcap_close(descr);
		       return(-1);
		    }

		  if (build_ip)
		    {
		       build_ip = 0;
		       t = libnet_build_ipv4(
					     LIBNET_IPV4_H + LIBNET_TCP_H,               /* length */
					     0,                                          /* TOS */
					     242,                                        /* IP ID */
					     0,                                          /* IP Frag */
					     64,                                         /* TTL */
					     IPPROTO_TCP,                                /* protocol */
					     0,                                          /* checksum */
					     src_ip,                                     /* source IP */
					     inet_addr(testip),                                     /* destination IP */
					     NULL,                                       /* payload */
					     0,                                          /* payload size */
					     l,                                          /* libnet handle */
					     0);
		       if (t == -1)
			 {
			    fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
			    libnet_destroy(l);
			    pcap_close(descr);
			    return(-1);
			 }

		    }
		  usleep(5);
		  c = libnet_write(l);
		  if (c == -1)
		    {
		       fprintf(stderr, "Error: %s\n", libnet_geterror(l));
		    }

		  for(;;)
		    {
		       tv.tv_sec = 2;
		       tv.tv_usec = 0;
		       FD_ZERO (&rfsd);
		       FD_SET (sd ,&rfsd);

		       pkt = (u_char *) pcap_next(descr,&pcap_h);
		       ip = (struct libnet_ipv4_hdr *) (pkt + offset);
		       icmp = (struct libnet_icmpv4_hdr *) (pkt + offset + LIBNET_IPV4_H);
		       Tcp = (struct libnet_tcp_hdr *) (pkt + offset + sizeof(struct libnet_ipv4_hdr));

		       if (Tcp->th_flags == (TH_RST|TH_ACK))
			 {
			    close++;
			    break;
			 }

		       service = getservbyport(htons(cport), "tcp");

		       if(ip->ip_p == IPPROTO_ICMP)
			 {
			    fprintf(log,"Filtered	%d		%s",cport,(service) ? service->s_name : "unknown");
			    fprintf(log,"				");
			    switch((icmp->icmp_type))
			      {

			       case 3:
				 switch (icmp->icmp_code)
				   {
				    case 0:
				      fprintf(log,"Network Unreachable");
				      break;
				    case 1:
				      fprintf(log,"Host Unreachable");
				      break;
				    case 2:
				      fprintf(log,"Protocol Unreachable");
				      break;
				    case 3:
				      fprintf(log,"Port Unreachable");
				      break;
				    case 6:
				      fprintf(log,"Destination network unknown");
				      break;
				    case 7:
				      fprintf(log,"Destination host unknown");
				      break;
				    case 8:
				      fprintf(log,"Source host isolated");
				      break;
				    case 9:
				      fprintf(log,"Destination network administratively prohibited");
				      break;
				    case 10:
				      fprintf(log,"Destination host administratively prohibited");
				      break;
				    case 11:
				      fprintf(log,"Network unreacjable(tos)");
				      break;
				    case 12:
				      fprintf(log,"Host Unreachable (tos)");
				      break;
				    case 13:
				      fprintf(log,"Communication administratively prohibited");
				      break;
				   }

				 break;
			       default:
				 fprintf(log,"%i", icmp->icmp_type);
				 break;
			      }
			    fprintf(log,"(*)\n");
			    fr++;
			    break;
			 }
		       if (Tcp->th_seq !=0 && Tcp->th_flags == (TH_SYN|TH_ACK))
			 {
			    //service = getservbyport(htons(cport), "tcp");
			    fprintf(log,"Open 	   	%d		%s",cport,(service) ? service->s_name : "unknown");
			    fprintf(log,"  			None\n");
			    break;
			 }
		       if (!select(sd+1, &rfsd, NULL, NULL, &tv))
			 {
			    //service = getservbyport(htons(cport), "tcp");
			    fprintf(log,"Filtered     	%d		%s",cport,(service) ? service->s_name : "unknown");
			    fprintf(log, " 			SYN packet timeout(**)\n");
			    fd++;
			    break;
			 }

		    }

	       }
	  }
	fprintf(log,"\nAll the other %d ports are in state closed\n",close);
	if (fr!=0) fprintf(log,"(*)Possible REJECT rule in the firewall\n");
	if (fd!=0) fprintf(log,"(**)Possible DROP rule in the firewall\n");

	libnet_destroy(l);
	pcap_close(descr);
	close=0;
	fd = 0; fr =0;
     }

   free (uphost);
   fprintf(log, "Scanning terminated on %s\n",timed);
   if (lg)
     {
	printf ("Done! Results has been writed to '%s'\n", logname);
	fclose (log);
     }

   printf ("\n");
   getchar();
   return 0;

}
